/*
 
Copyright (C) 2009 NTT DATA Corporation
 
This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License 
as published by the Free Software Foundation, version 2.
 
This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
PURPOSE.  See the GNU General Public License for more details.
 
*/

package com.clustercontrol.vm.ejb.mdb;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import com.clustercontrol.vm.ejb.entity.VmOperationDetailData;
import com.clustercontrol.vm.ejb.session.VmControllerLocal;
import com.clustercontrol.vm.ejb.session.VmControllerUtil;

/**
 *
 * <!-- begin-user-doc --> You can insert your documentation for '<em><b>VmStatusBean</b></em>'. <!-- end-user-doc --> *
 *
 *
 * <!-- begin-xdoclet-definition -->
 * @ejb.bean name="VmStatusBean" 
 *     acknowledge-mode="Auto-acknowledge"
 *     destination-type="javax.jms.Queue"
 *     transaction-type="Bean"
 *     destination-jndi-name="queue/clustercontrolVmControlStatus"
 * 
 * @jboss.depends name="jboss.j2ee:service=EJB,jndiName=AccessController"
 * @jboss.depends name="jboss.j2ee:service=EJB,jndiName=RepositoryController"
 * @jboss.depends name="jboss.j2ee:service=EJB,jndiName=JobController"
 * @jboss.depends name="jboss.j2ee:service=EJB,jndiName=QuartzManager"
 * 
 * @jboss.container-configuration 
 *     name="Singleton Message Driven Bean" 
 *
 *--
 * Server Runtime Specific Tags
 * If you are not using a specific runtime, you can safely remove the tags below.
 * @jonas.message-driven-destination jndi-name="queue/clustercontrolVmControlStatus"
 * @jboss.destination-jndi-name name="queue/clustercontrolVmControlStatus"
 *
 *--
 * <!-- end-xdoclet-definition -->
 * @generated
 **/
public class VmStatusBean implements javax.ejb.MessageDrivenBean, javax.jms.MessageListener {
    protected static Log m_log = LogFactory.getLog( VmStatusBean.class );
    
    /** 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * The context for the message-driven bean, set by the EJB container. 
     * @generated
     */
    private javax.ejb.MessageDrivenContext messageContext = null;

    /** 
     * Required method for container to set context.
     * @generated 
     */
    public void setMessageDrivenContext(
            javax.ejb.MessageDrivenContext messageContext)
            throws javax.ejb.EJBException {
        this.messageContext = messageContext;
    }

    /** 
     * Required creation method for message-driven beans. 
     *
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     *
     * <!-- begin-xdoclet-definition -->
     * @ejb.create-method 
     * <!-- end-xdoclet-definition -->
     * @generated
     */
    public void ejbCreate() {
        //no specific action required for message-driven beans 
    }

    /** 
     * Required removal method for message-driven beans. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void ejbRemove() {
        messageContext = null;
    }

    /** 
     * This method implements the business logic for the EJB. 
     * 
     * <p>Make sure that the business logic accounts for asynchronous message processing. 
     * For example, it cannot be assumed that the EJB receives messages in the order they were 
     * sent by the client. Instance pooling within the container means that messages are not 
     * received or processed in a sequential order, although individual onMessage() calls to 
     * a given message-driven bean instance are serialized. 
     * 
     * <p>The <code>onMessage()</code> method is required, and must take a single parameter 
     * of type javax.jms.Message. The throws clause (if used) must not include an application 
     * exception. Must not be declared as final or static. 
     *
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void onMessage(javax.jms.Message message) {
    	
    	
    	m_log.debug("onMessage() : start");

    	//受信オブジェクトの確認(ObjectMessage)
        if (message instanceof ObjectMessage) {
            ObjectMessage objectMessage = (ObjectMessage) message;
            Object obj;
            try {
                obj = objectMessage.getObject();
            } catch (JMSException e) {
                m_log.error("onMessage() : An illegal message was received.", e);
                return;
            }

            //受信オブジェクトの確認(VmOperationDetailData)
            if (obj instanceof VmOperationDetailData) {
                
            	VmOperationDetailData data = (VmOperationDetailData) obj;

            	m_log.debug("onMessage() : VmOperationDetailData was received. : SessionID=" + data.getSessionId());

              try {
					//コマンド実行
					exec(data);
				} catch (Exception e) {
					m_log.warn("Debug For VmStatusBean -> " + e.getMessage(), e);
				} finally {
					
				}

            } else {
                m_log.error("onMessage() : An illegal message was received." + obj.toString());
                return;
            }
        } else {
            m_log.error("onMessage() : An illegal message was received." + message.getClass());
            return;
        }
        m_log.debug("onMessage() : end");
        
    }
    
    
    
    /*
     * (non-Javadoc)
     * 
     * @see java.lang.Runnable#run()
     */
    public void exec(VmOperationDetailData data) throws Exception{
    	
		m_log.debug("exec() : start sessionId = " + data.getSessionId() + ", facilityId = " + data.getFacilityId());

    	VmControllerLocal local = VmControllerUtil.getLocalHome().create();
    	local.endNode(data);

		m_log.debug("exec() : end sessionId = " + data.getSessionId() + ", facilityId = " + data.getFacilityId());

    }

}
